;*************************************************************************;
;*                                                                       *;
;*                    OPIN                                               *;
;*     Oblben programtorovy nstroje                                  *;
;*                                                                       *;
;*************************************************************************;

; Assembled and linked with Borland Turbo Assembler 2.01, Turbo Link 3.01
; TASM /z OPIN
; TLINK /t /x OPIN

IDEAL
%CTLS
%NOINCL
%NOSYMS
%TRUNC
%MACS
; Macrolibraries can be downloaded from http://vitsoft.info/VSASMLIB.zip
INCLUDE "CPU.MAC"
INCLUDE "CRT.MAC"
INCLUDE "CZECH.MAC"
INCLUDE "DOS.MAC"
INCLUDE "KBD.MAC"
INCLUDE "SOUND.MAC"
INCLUDE "STR.MAC"
INCLUDE "SW.MAC"

MODEL          TINY
SEGMENT        COM
ASSUME         CS:COM, DS:COM, ES:COM, SS:COM
ORG            256

Start:      JMP  Main
;DATA
LABEL Help$ BYTE
DB $CR,$LF
DB 'Program:  OPIN  ver. 1.00          freeware 1996 by vit$oft',$CR,$LF
DB '          Oblben programtorovy inspekcn nstroje',$CR,$LF
DB '          Programmer''s favourite inspection tools',$CR,$LF,$LF
DB 'Syntax:   OPIN Attr  ... display screen color attributes',$CR,$LF
DB '          OPIN CRTC  ... display Cathode Ray Tube Controller registers',$CR,$LF
DB '          OPIN Font  ... display character font',$CR,$LF
DB '          OPIN Keys  ... display information from keyboard',$CR,$LF
DB '          OPIN Mouse ... display information from mouse',$CR,$LF
DB 0

LABEL EndText$ BYTE
D$ Param$,50


DSw <swE,swN,swEnd,sw40,swBlink>

;CODE
PROC Main
     CALL GetVMode
     GetParam 1,Param$
     JNA Help
     MOV AL,[Param$]
     CMP AL,'/'
     JE @@20
     CMP AL,'-'
     JNE @@30
@@20:MOV AL,[Param$+1]
@@30:AND AL,NOT 'a'-'A'
     CMP AL,'A'
     JmpIf E,opAttr
     CMP AL,'C'
     JmpIf E,opCrtc
     CMP AL,'F'
     JmpIf E,opFont
     CMP AL,'K'
     JmpIf E,opKeys
     CMP AL,'M'
     JmpIf E,opMouse
Help:WriteLn ,Help$
     Terminate 8
ENDP Main
          ;0123456789012345678901235678
VMode$ DB 'Videomode xxh (cccxrr) graph(hhhhxvvv)',0
VMode  DB 3
Text$  DB 'text',0
Graph$ DB 'graph('
Resols DB 'hhhhxvvv)',0
MaxLineNr  DB 25 ; poet dek displeje
MaxCol     DB 80 ; poet sloupc
Lines  DW 480    ; poet scan dk

PROC GetVMode
     PickMode
     MOV [VMode],AL
     PUSH AX
      StoHB [VMode$+10]
     POP AX
     MOV AL,AH
     MOV [MaxCol],AL
     CMP AL,40
     JNE @@2
     SetSw sw40
@@2: SUB AH,AH
     PUSH AX
      MOV CL,3
      SHL AX,CL
      STD
      StoDW [Resols+3],4
     POP AX
     StoDB [VMode$+17],3
     SUB AX,AX
     MOV ES,AX
     MOV AL,[ES:484h] ; row/page
     INC AL
     CMP AL,25
     JAE @@3
     MOV AL,25
@@3: MOV [MaxLineNr],AL
     CLD
     PUSH DS
     POP ES
     StoDB [VMode$+19],2
     SUB AX,AX
     MOV ES,AX
     MOV DX,[ES:463h] ; CRTC adr
     CLI
      MOV AL,12h
      OUT DX,AL
      IN  AX,DX
      MOV CL,AH
      MOV AL,7
      OUT DX,AL
      IN  AX,DX
     STI
     SHR AX,1
     SHR AX,1
     SHR AH,1
     SHR AH,1
     SHR AH,1
     SHR AH,1
     SHL AX,1
     AND AH,3
     MOV AL,CL
     INC AX
     MOV [Lines],AX
     CLD
     PUSH DS
     POP ES
     StoDW [Resols+5],3
     SUB AX,AX
     MOV ES,AX
     MOV DX,[ES:463h]
     PUSH DS
     POP ES
     ADD DL,6 ; port 3DA nebo 3BA
     CLI
      IN AL,DX
      MOV DL,0C0h
      MOV AL,10h+20h
      OUT DX,AL
      IN AX,DX
     STI
     LEA SI,[Text$]
     TEST AH,1  ; graph/text
     JZ @@5
     CMP [VMode$+10],'0'
     JNE @@4
     CMP [VMode$+11],'7' ; Hercules?
     JE @@5
     CMP [VMode$+11],'3' ; CGA
     JBE @@5
@@4: LEA SI,[Graph$]
@@5: Mov$ [VMode$+23]
     RET
ENDP GetVMode


LABEL aTab BYTE
DB 'Ŀ',0
DB '   COLOR      Bk Bl Gn Cy Rd Mg Bw Wh Gr BB BG BC BR BM BY BW  MONOCHROME    ',0
DB 'Ĵ',0
DB 'Black        00102030405060708090A0B0C0D0E0F0Underline    01',0
DB 'Blue         01112131415161718191A1B1C1D1E1F1Normal       07',0
DB 'Green        02122232425262728292A2B2C2D2E2F2GrayOnBlack  08',0
DB 'Cyan         03132333435363738393A3B3C3D3E3F3BrightUn     09',0
DB 'Red          04142434445464748494A4B4C4D4E4F4Bright       0F',0
DB 'Magenta      05152535455565758595A5B5C5D5E5F5Inverse      70',0
DB 'Brown        06162636465666768696A6B6C6D6E6F6GrayOnWhite  78',0
DB 'White        07172737475767778797A7B7C7D7E7F7BrightOnWhite7F',0
DB 'Gray         08182838485868788898A8B8C8D8E8F8BlackOnGray  80',0
DB 'BrightBlue   09192939495969798999A9B9C9D9E9F9FlashUn      81',0
DB 'BrightGreen  0A1A2A3A4A5A6A7A8A9AAABACADAEAFAFlash        87',0
DB 'BrightCyan   0B1B2B3B4B5B6B7B8B9BABBBCBDBEBFBFlashBrightUn89',0
DB 'BrightRed    0C1C2C3C4C5C6C7C8C9CACBCCCDCECFCBrightOnGray 8F',0
DB 'BrightMagenta0D1D2D3D4D5D6D7D8D9DADBDCDDDEDFDFlashInverse F0',0
DB 'BrightYellow 0E1E2E3E4E5E6E7E8E9EAEBECEDEEEFEWhiteOnBrightF7',0
DB 'BrightWhite  0F1F2F3F4F5F6F7F8F9FAFBFCFDFEFFFGrayOnBright F8',0
DB '',0

LABEL aTab256 BYTE
DB 'Ŀ',0
DB '      0 1 2 3 4 5 6 7 8 9 A B C D E F ',0
DB '     Ĵ',0
DB 'Bk  000102030405060708090A0B0C0D0E0F0',0
DB 'Bl  101112131415161718191A1B1C1D1E1F1',0
DB 'Gn  202122232425262728292A2B2C2D2E2F2',0
DB 'Cy  303132333435363738393A3B3C3D3E3F3',0
DB 'Rd  404142434445464748494A4B4C4D4E4F4',0
DB 'Mg  505152535455565758595A5B5C5D5E5F5',0
DB 'Bw  606162636465666768696A6B6C6D6E6F6',0
DB 'Wh  707172737475767778797A7B7C7D7E7F7',0
DB 'Gr  808182838485868788898A8B8C8D8E8F8',0
DB 'BB  909192939495969798999A9B9C9D9E9F9',0
DB 'BG  A0A1A2A3A4A5A6A7A8A9AAABACADAEAFA',0
DB 'BC  B0B1B2B3B4B5B6B7B8B9BABBBCBDBEBFB',0
DB 'BR  C0C1C2C3C4C5C6C7C8C9CACBCCCDCECFC',0
DB 'BM  D0D1D2D3D4D5D6D7D8D9DADBDCDDDEDFD',0
DB 'BY  E0E1E2E3E4E5E6E7E8E9EAEBECEDEEEFE',0
DB 'BW  F0F1F2F3F4F5F6F7F8F9FAFBFCFDFEFFF',0
DB '',0
aF1$ DB 'Blink disabled (Enter to togle)',0
aF2$ DB 'Blink enabled  (Enter to togle)',0
aF3$ DB 'Press Esc to quit.',0

RADIX 16
MonoCols DB 01,07,08,09,0F,70,78,7F,80,81,87,89,8F,0F0,0F7,0F8
RADIX 10

aColor  DB  0
Col     DB 0
Row     DB 0

PROC opAttr
     ClrScr
     PickMode
     StoreCursor
     HideCursor
     DisableBlink
     Show$ VMode$,Normal
     LEA SI,[aTab]
     JNSw sw40,@@06
     LEA SI,[aTab256]
@@06:MOV BL,Normal
     MOV [Row],1
     MOV CX,20
@@10:PUSH CX
      ShowAt [Row],0
      PUSH SI
       Show$ SI,BL     ; ernobl kostra
      POP SI
      ADD SI,41
      JSw sw40,@@14
      ADD SI,40
@@14: INC [Row]
     POP CX
     LOOP @@10
     MOV [aColor],0
     JNSw sw40,@@19
     MOV [Col],7
     MOV CL,16
@@15:PUSH CX
      MOV [Row],4
      MOV CL,16
@@16: PUSH CX
       CALL Show1
       INC [aColor]
       INC [Row]
      POP CX
      LOOP @@16
      ADD [Col],2
     POP CX
     LOOP @@15
@@19:JSw sw40,@@80
     MOV [Col],15
     MOV CL,16
@@20:PUSH CX
      MOV [Row],4
      MOV CL,16
@@30: PUSH CX
       CALL Show1
       INC [aColor]
       INC [Row]
      POP CX
      LOOP @@30
      ADD [Col],3
     POP CX
     LOOP @@20
     MOV [Row],4
     MOV [Col],77
     LEA SI,[MonoCols]
     MOV CL,16
@@50:PUSH CX
      CLD
      LODSB
      MOV [aColor],AL
      PUSH SI
       CALL Show1
      POP SI
      INC [Row]
     POP CX
     LOOP @@50
@@80:SUB BX,BX
     ShowAt 21,0
     JSw swBlink,@@84
     DisableBlink
     Show$ aF1$,Normal
@@84:JNSw swBlink,@@86
     EnableBlink
     Show$ aF2$,Normal
@@86:ShowAt 22,0
     Show$ aF3$,Normal
     ReadKey
     CMP AH,ScanEsc
     JE @@90
     InvSw swBlink
     JMP @@80
@@90:Terminate
ENDP opAttr

hColor DB 'xx'

PROC Show1 ; zobraz barvu aColor hexadecimln na [Row],[Col]
     MOV AL,[aColor]
     StoHB [hColor]
     SUB BX,BX
     ShowAt [Row],[Col]
     MOV AL,[hColor]
     ShowChar [hColor+0],1,[aColor]
     ShowChar [hColor+1],1,[aColor],*
     RET
ENDP Show1


CRTC$   DB $CR,$LF,'CRTC registers',$CR,$LF,0
Values$ DB '00 01 02 03 04 05 06 07',$CR,$LF
Values1 DB 'xx xx xx xx xx xx xx xx',$CR,$LF,$LF
        DB '08 09 0A 0B 0C 0D 0E 0F',$CR,$LF
Values2 DB 'xx xx xx xx xx xx xx xx',$CR,$LF,$LF
        DB '10 11 12 13 14 15 16 17 18',$CR,$LF
Values3 DB 'xx xx xx xx xx xx xx xx xx',$CR,$LF
        DB 0

PROC opCrtc
      SUB AX,AX
      MOV ES,AX
      MOV DX,[ES:463h]
      PUSH DS
      POP ES
      CLI
      SUB BX,BX
      LEA DI,[Values1]
      MOV CX,8
@@1:  MOV AL,BL
      OUT DX,AL
      IN  AX,DX
      MOV AL,AH
      StoHB
      INC DI
      INC BX
      LOOP @@1
      LEA DI,[Values2]
      MOV CX,8
@@2:  MOV AL,BL
      OUT DX,AL
      IN  AX,DX
      MOV AL,AH
      StoHB
      INC DI
      INC BX
      LOOP @@2
      LEA DI,[Values3]
      MOV CX,9
@@3:  MOV AL,BL
      OUT DX,AL
      IN  AX,DX
      MOV AL,AH
      StoHB
      INC DI
      INC BX
      LOOP @@3
      STI
      WriteLn ,VMode$
      WriteLn ,CRTC$
      WriteLn ,Values$
    Terminate
ENDP opCrtc

fH1 DB 'Ŀ',0
fH2 DB '     0 1 2 3 4 5 6 7 8 9 A B C D E F ',0
fH3 DB '   Ĵ',0
fH4 DB ' 0                                  ',0
fH5 DB '',0
Char	  DB 0

PROC opFont
        ClrScr
	PickMode
        ShowAt$ 0,0,VMode$,Normal
        ShowAt$ 1,0,fH1,Normal
        ShowAt$ 2,0,fH2,Normal
        ShowAt$ 3,0,fH3,Normal
        MOV CX,16
        MOV [Row],4
        MOV [Col],6
@@10:   PUSH CX
         ShowAt$ [Row],0,fH4,Normal
         SUB BX,BX
         MOV BL,[Col]
         MOV AL,[BX+fH2]
         ShowAt [Row],2
         ShowChar AL,1,Normal,*
         INC [Row]
         INC [Col]
         INC [Col]
        POP CX
        LOOP @@10
        ShowAt$ 20,0,fH5,Normal
        MOV [Char],0
        MOV [Col],6
@@20:   MOV [Row],4
        MOV CX,16
@@30:   PUSH CX
         ShowAt [Row],[Col]
         ShowChar [Char],1,Normal,*
         INC [Char]
         INC [Row]
        POP CX
        LOOP @@30
        INC [Col]
        INC [Col]
        CMP [Col],16*2+6
        JB @@20
        ShowAt 21,0
     Terminate
ENDP opFont


OldInt9 DD 0
PortD DB '   ',0
PortH DB 'xx',0
KeyW DB 'yyyy',0



LABEL kRastr BYTE
DB '                                                                   ',0
DB '                                         7  Insert Lock  Insert    ',0
DB '                                         6  Caps Lock    Caps      ',0
DB '                                         5  Num Lock     Num       ',0
DB '                                         4  Scrl Lock    Scrl      ',0
DB '                                                                   ',0
DB '                                         3  Alt          Pause     ',0
DB '                                         2  Ctrl         SysRq     ',0
DB '                                         1  Left Shift   Left Alt  ',0
DB '                                         0  Right Shift  Left Ctrl ',0
DB 'Ĵ',0
DB 'KeyboardAH=scan  AL=char   40h:17h  40h:18h                              ',0
DB 'port 60h  BIOS INT 16h             Keyboard flags in RAM                    ',0
DB 'Ĵ',0
DB '123412341234123412341234123412341234123412341234123412341234123',0
DB 'Alt-N 40h:19h=123dKeyboard buffer at 40h:1EhPress mouse or type END to quit.',0
DB '',0


STRUC KeyRec
 Port DB 0
 Char DB 0
 Scan DB 0
 Flag DW 0
 AltN DB 0
 Head DW 0
 Tail DW 0
 KBuf DW 16 DUP (0)

ENDS KeyRec

; Na Heapu je kruhov bufer pro zznamy KeyRec.
; INT9 pe na KeyRecTail^, Main zobrazuje z KeyRecHead^.
; Je-li KeyRecHead=KeyRecTail, je ve zobrazeno.
KeyRecHead DW OFFSET Heap ; Ptr na dosud nezobrazen KeyRec
KeyRecTail DW OFFSET Heap ; Ptr na prvn voln KeyRec
KeyRecEnd  DW OFFSET Heap + 51*SIZE KeyRec
Timer      DW 0 ; systmov tiky pi poslednm INT9


PROC NewInt9
      PUSH AX CX SI DI DS ES
       SUB CX,CX
       MOV ES,CX
       MOV AX,[ES:46Ch]
       MOV CX,CS
       MOV DS,CX
       MOV ES,CX
       MOV CX,AX
       XCHG AX,[Timer]
       CMP AX,CX
       JE @@10
       INC AX
       CMP AX,CX
       JE @@10
       INC AX
       CMP AX,CX
       JE @@10
       INC AX
       CMP AX,CX
       JE @@10
       INC AX
       CMP AX,CX
       JE @@10
       MOV DI,[KeyRecTail]
       MOV [(KeyRec DI).Port],0 ; vynechat dek
       ADD DI,SIZE KeyRec
       CMP DI,[KeyRecEnd]
       JB @@06
       LEA DI,[Heap]
@@06:  MOV [KeyRecTail],DI

@@10:  IN AL,60h
@@20:  MOV DI,[KeyRecTail]
       MOV [(KeyRec DI).Port],AL
       PUSHF
       CALL [OldInt9]
       MOV AH,1
       INT 16h
       MOV AX,-1
       JZ @@30
       SUB AX,AX
       INT 16h
@@30:  MOV [WORD (KeyRec DI).Char],AX ; -1=not available
       SUB AX,AX
       MOV DS,AX
       LEA DI,[(KeyRec DI).Flag]
       MOV SI,417h ; flags
       CLD
       MOVSB
       MOV CX,19
       REP MOVSW
       PUSH ES
       POP DS
       CMP DI,[KeyRecEnd]
       JB @@50
       LEA DI,[Heap]
@@50:  MOV [KeyRecTail],DI
@@90:POP ES DS DI SI CX AX
     IRET
ENDP NewInt9

;           01234567890123456789012345678901234567890123456789
NewLine DB '123dFFh123dFFh123dFFhA7654 32107654 3210',0
NewGrid DB '                                        ',0
BufLine DB 80 DUP (Space),0
AltN$   DB '123d',0

PROC kUpdate ; zobraz 1 dek z Heapu dle KeyHead^
     MOV SI,[KeyRecHead]
     CMP SI,[KeyRecTail]
     JmpIf E,@@90
     PUSH SI
      Mov$ [NewLine],[NewGrid]
     POP SI
     MOV AL,[(KeyRec SI).Port]
     TEST AL,AL
     JmpIf Z,@@51
     STD
     StoDB [NewLine+3],3
     MOV [NewLine+4],'d'
     StoHB [NewLine+6]
     MOV [NewLine+8],'h'
     MOV AX,[WORD (KeyRec SI).Char]
     INC AX
     JmpIf Z,@@20
     DEC AX
     PUSH AX
      TEST AL,AL
      JNZ @@10
      MOV AL,Space
@@10: MOV [NewLine+28],AL
     POP AX
     STD
     StoDB [NewLine+21],3
     MOV [NewLine+22],'d'
     StoHB [NewLine+24]
     MOV [NewLine+26],'h'
     MOV AL,[(KeyRec SI).Scan]
     STD
     StoDB [NewLine+12],3
     MOV [NewLine+13],'d'
     PUSH AX
      StoHB [NewLine+15]
     POP AX
     MOV [NewLine+17],'h'
     JNSw swN,@@12
     CMP AL,ScanD
     JNE @@19
     SetSw swEnd
@@12:JNSw swE,@@15
     CMP AL,ScanN
     JNE @@19
     SetSw swN
     JMP SHORT @@20
@@15:CMP AL,ScanE
     JNE @@19
     SetSw swE
     JMP SHORT @@20
@@19:RstSw <swE,swN>
@@20:LEA DI,[NewLine+30]
     MOV DX,[(KeyRec SI).Flag]
     XCHG DH,DL
     MOV BL,4
     CLD
@@30:MOV CX,4
@@40:MOV AL,'.'
     SHL DX,1
     JNC @@50
     MOV AL,'I'
@@50:STOSB
     LOOP @@40
     INC DI
     DEC BL
     JNZ @@30
@@51:SUB CX,CX
     MOV DH,[MaxLineNr]
     SUB DH,8
     MOV DL,48
     MOV AX,0601h
     MOV BH,Normal
     INT 10h ; scroll up 1
     SUB BX,BX
     SUB DL,DL
     PUSH DX
      PUSH SI
       ShowAt DX
       Show$ NewLine,Normal
      POP SI
      ; Alt-N
      MOV AL,[(KeyRec SI).AltN]
      STD
      StoDB [AltN$+2],3
      ADD DH,6
      PUSH SI
       ShowAt DH,15
       Show$ AltN$,Normal
      POP SI
      ; Tail
      SUB DH,2
      MOV DL,1
      MOV AH,9
      MOV BX,Normal
      MOV CX,1
      MOV BP,1Eh ; start Buffer
@@52: MOV AL,BoxSMC
      CMP BP,[(KeyRec SI).Tail]
      JNE @@54
      MOV AL,ArrowD
@@54: CMP BP,[(KeyRec SI).Head]
      JNE @@56
      MOV AL,ArrowD
@@56: PUSH AX
       ShowAt DX
      POP AX
      INT 10h ; Show char&attr
      ADD DL,5
      ADD BP,2
      CMP BP,1Eh+2*16
      JB @@52
      ; bufer
      LEA SI,[(KeyRec SI).KBuf]
      LEA DI,[BufLine]
      MOV CX,16
      CLD
@@60: MOV AL,BoxSCM
      STOSB
      LODSW
      StoHW
      LOOP @@60
     POP DX
     ADD DH,5
     ShowAt DX
     Show$ BufLine,Normal

     MOV AX,[KeyRecHead]
     ADD AX,SIZE KeyRec
     CMP AX,[KeyRecEnd]
     JB @@85
     LEA AX,[Heap]
@@85:MOV [KeyRecHead],AX
@@90:RET
ENDP kUpdate


NoMem$ DB 'Not enough memory.',0

PROC opKeys
     MOV AX,SP
     SUB AX,2048
     CMP AX,OFFSET Heap
     JA @@10
     WriteLn ,Nomem$
     Terminate
@@10:ADD AX,1024
     MOV [KeyRecEnd],AX
     StoreCursor
     HideCursor
     InitMouse
     SUB AX,AX
     MOV AL,[MaxLineNr]
     SUB AL,16
     MOV CX,AX ; poet stejnch hornch dk
     SUB BX,BX
     SUB DX,DX
@@20:PUSH CX
      SUB DL,DL
      ShowAt DX
      LEA SI,[kRastr]
      Show$ SI,Normal
      INC DH
     POP CX
     LOOP @@20 ; 9 stejnch hornch dk
     MOV CL,16
@@30:PUSH CX
      SUB DL,DL
      ShowAt DX
      Show$ SI,Normal
      INC DH
     POP CX
     LOOP @@30 ; 16 dolnch dk
     LEA AX,[Heap]
     MOV [KeyRecHead],AX
     MOV [KeyRecTail],AX
     GetIntVec 9
     MOV [WORD OldInt9+0],BX
     MOV [WORD OldInt9+2],ES
     PUSH DS
     POP ES
     LEA DX,[NewInt9]
     SetIntVec 9
@@40:CALL kUpdate
     JSw swEnd,@@90
     SUB BX,BX
     ReadMouse
     TEST BX,AnyMouseButton
     JZ @@40
@@90:PUSH DS
      LDS DX,[OldInt9]
      SetIntVec 9
     POP DS
     MOV DH,[MaxLineNr]
     DEC DH
     MOV DL,80
     SUB BX,BX
     ShowAt DX
     ShowChar Space,80,Normal,nomove
     RestoreCursor
     SUB    CX,CX
     MOV    BH,Normal
     MOV    AX,0601h
     INT    10h ;scroll up 1
     Terminate
ENDP opKeys

mNot$ DB $CR,$LF,'Mouse driver not installed.',0

LABEL mTab BYTE
DB '       INT 33h AX=3',0
DB 'Ŀ              ',0
DB '   Buttons BX=',0
DB '      Column  CX=',0
DB '   Row     DX=',0
mQ$ DB 'Press any key to quit.',0


mBut$ DB 'xxxxx',0
mCol$ DB 'xxxxx',0
mRow$ DB 'xxxxx',0
Stuf$ DB '',0


PROC opMouse
     ClrScr
     PickMode
     StoreCursor
     HideCursor
     DisableBlink
     WriteLn ,VMode$
     InitMouse
     INC AX
     JZ @@10
     WriteLn ,mNot$
     Terminate
@@10:CMP [VMode],13h
     JBE @@18
     MOV DX,[Lines]
     DEC DX
     SUB CX,CX
     MOV AX,8
     INT 33h ; set vert.range
     SUB DX,DX
     MOV DL,[MaxCol]
     MOV CL,3
     SHL DX,CL
     DEC DX
     SUB CX,CX
     MOV AX,7
     INT 33h ; set hor.range
@@18:MOV [Row],5
     LEA SI,[mTab]
     MOV CX,5
@@20:PUSH CX
      ShowAt$ [Row],8,SI,Normal
      INC [Row]
     POP CX
     LOOP @@20
     ShowAt$ 13,0,mQ$,Normal
     ShowMouse

@@30:KeyPressed?
     JmpIf NZ,@@90
     ReadMouse
     CLD
     MOV AX,BX
     StoDW [mBut$]
     MOV AX,CX
     StoDW [mCol$]
     MOV AX,DX
     StoDW [mRow$]
     MOV DX,Stuff1+256*Stuff4
     LEA DI,[Stuf$]
     MOV AL,DL
     TEST BL,1
     JZ @@40
     MOV AL,DH
@@40:STOSB
     MOV AL,DL
     TEST BL,4
     JZ @@50
     MOV AL,DH
@@50:STOSB
     MOV AL,DL
     TEST BL,2
     JZ @@60
     MOV AL,DH
@@60:STOSB
     SUB BX,BX
     ShowAt$ 7,9,Stuf$,Normal
     ShowAt$ 7,27,mBut$,Normal
     ShowAt$ 8,27,mCol$,Normal
     ShowAt$ 9,27,mRow$,Normal
     JMP @@30
@@90:
     HideMouse
     RestoreCursor
     ShowAt 14,0
     Terminate
ENDP opMouse

     EVEN
LABEL Heap BYTE


ENDS           COM
END            Start
